# SimVision Command Script

#
# groups
#

if {[catch {group new -name {System Signals} -overlay 0}] != ""} {
    group using {System Signals}
    group set -overlay 0
    group set -comment {}
    group clear 0 end
}
group insert \
    :reset \
    :brefclk_p \
    :brefclk_n
    :signal_detect1 \

if {[catch {group new -name {Management I/F 1} -overlay 0}] != ""} {
    group using {Management I/F}
    group set -overlay 0
    group set -comment {}
    group clear 0 end
}
group insert \
    :dut.configuration_vector1 \
    :status_vector1

if {[catch {group new -name {Tx GMII 1} -overlay 0}] != ""} {
    group using {Tx GMII}
    group set -overlay 0
    group set -comment {}
    group clear 0 end
}
group insert \
    :gmii_txd1 \
    :gmii_tx_en1 \
    :gmii_tx_er1

if {[catch {group new -name {Rx GMII 1} -overlay 0}] != ""} {
    group using {Rx GMII}
    group set -overlay 0
    group set -comment {}
    group clear 0 end
}
group insert \
    :gmii_rxd1 \
    :gmii_rx_dv1 \
    :gmii_rx_er1

if {[catch {group new -name {Transceiver Tx 1} -overlay 0}] != ""} {
    group using {Transceiver Tx}
    group set -overlay 0
    group set -comment {}
    group clear 0 end
}
group insert \
    :txp1 \
    :txn1

if {[catch {group new -name {Transceiver Rx 1} -overlay 0}] != ""} {
    group using {Transceiver Rx}
    group set -overlay 0
    group set -comment {}
    group clear 0 end
}
group insert \
    :rxp1 \
    :rxn1

if {[catch {group new -name {Tx Monitor 1} -overlay 0}] != ""} {
    group using {Tx Monitor}
    group set -overlay 0
    group set -comment {}
    group clear 0 end
}
group insert \
    :stimulus_1.mon_tx_clk \
    :stimulus_1.tx_pdata \
    :stimulus_1.tx_is_k \
    :stimulus_1.bitclock
if {[catch {group new -name {Rx Stimulus 1} -overlay 0}] != ""} {
    group using {Rx Stimulus}
    group set -overlay 0
    group set -comment {}
    group clear 0 end
}
group insert \
    :stimulus_1.stim_rx_clk \
    :stimulus_1.rx_even \
    :stimulus_1.rx_pdata \
    :stimulus_1.rx_is_k \
    :stimulus_1.rx_rundisp_pos

if {[catch {group new -name {Test semaphores} -overlay 0}] != ""} {
    group using {Test semaphores}
    group set -overlay 0
    group set -comment {}
    group clear 0 end
}
    :configuration_finished \
    :tx_monitor_finished1 \
    :rx_monitor_finished1 \
    :simulation_finished
#
# Waveform windows
#
if {[window find -match exact -name "Waveform 1"] == {}} {
    window new WaveWindow -name "Waveform 1" -geometry 906x585+25+55
} else {
    window geometry "Waveform 1" 906x585+25+55
}
window target "Waveform 1" on
waveform using {Waveform 1}
waveform sidebar visibility partial
waveform set \
    -primarycursor TimeA \
    -signalnames name \
    -signalwidth 175 \
    -units fs \
    -valuewidth 75
cursor set -using TimeA -time 50,000,000,000fs
cursor set -using TimeA -marching 1
waveform baseline set -time 0

set groupId [waveform add -groups {{System Signals}}]

set groupId [waveform add -groups {{Management I/F 1}}]

set groupId [waveform add -groups {{Tx GMII 1}}]

set groupId [waveform add -groups {{Rx GMII 1}}]

set groupId [waveform add -groups {{Transceiver Tx 1}}]

set groupId [waveform add -groups {{Transceiver Rx 1}}]


set groupId [waveform add -groups {{Tx Monitor 1}}]

set groupId [waveform add -groups {{Rx Stimulus 1}}]

set groupId [waveform add -groups {{Test semaphores}}]

waveform xview limits 0fs 10us

simcontrol run -time 200us
