----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    17:52:21 03/19/2013 
-- Design Name: 
-- Module Name:    linktest - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
use IEEE.std_logic_misc.all;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity linktest is
    Port ( sysclk : in  STD_LOGIC;
           LINKrxdata : in  STD_LOGIC_VECTOR(15 downto 0);
           LINKrxcharisk : in  STD_LOGIC_VECTOR(1 downto 0);
           LINKtxdata : out  STD_LOGIC_VECTOR(15 downto 0);
           LINKtxcharisk : out  STD_LOGIC_VECTOR(1 downto 0);
           V6_DONE : in  STD_LOGIC;
           SN : in  STD_LOGIC_VECTOR (7 downto 0));
end linktest;

architecture Behavioral of linktest is
signal V6_OK_cntr : std_logic_vector(7 downto 0) := (others =>'0');
signal div : std_logic_vector(3 downto 0) := (others =>'0');

begin
process(sysclk)
begin
	if(sysclk'event and sysclk = '1')then
		if(div(3) = '1')then
			LINKtxcharisk(0) <= '1';
			LINKtxdata(7 downto 0) <= x"bc";
		else
			LINKtxcharisk(0) <= '0';
			LINKtxdata(7 downto 0) <= x"00";
		end if;
		if(div(3) = '1')then
			div <= (others => '0');
		else
			div <= div + 1;
		end if;
		if(V6_OK_cntr(7) = '0')then
			LINKtxcharisk(1) <= '0';
			LINKtxdata(15 downto 8) <= x"00";
		elsif(div(3) = '1')then
			LINKtxcharisk(1) <= '1';
			LINKtxdata(15 downto 8) <= x"bc";
		else
			LINKtxcharisk(1) <= '0';
			LINKtxdata(15 downto 8) <= SN;
		end if;
		if(V6_Done = '0')then
			V6_OK_cntr <= (others => '0');
		elsif(LINKrxcharisk(0) = '1' and LINKrxdata(7 downto 0) = x"bc" and V6_OK_cntr(7) = '0')then
			V6_OK_cntr <= V6_OK_cntr + 1;
		end if;
	end if;
end process;


end Behavioral;

