----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    17:52:21 03/19/2013 
-- Design Name: 
-- Module Name:    linktest - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
use IEEE.std_logic_misc.all;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity linktestb is
    Port ( sysclk : in  STD_LOGIC;
           LINKrxdata : in  STD_LOGIC_VECTOR(15 downto 0);
           LINKrxcharisk : in  STD_LOGIC_VECTOR(1 downto 0);
           LINKtxdata : out  STD_LOGIC_VECTOR(15 downto 0);
           LINKtxcharisk : out  STD_LOGIC_VECTOR(1 downto 0);
           S6LinkRdy_n : in  STD_LOGIC;
           got_SN : out  STD_LOGIC;
           SN : out  STD_LOGIC_VECTOR (7 downto 0));
end linktestb;

architecture Behavioral of linktestb is
signal S6LinkCntr : std_logic_vector(7 downto 0) := (others =>'0');
signal SN_T2 : std_logic_vector(7 downto 0) := (others =>'0');
signal SN_cntr : std_logic_vector(4 downto 0) := (others =>'0');
signal div : std_logic_vector(3 downto 0) := (others =>'0');
signal got_SNp : std_logic := '1';

begin
process(sysclk)
begin
	if(sysclk'event and sysclk = '1')then
		if(SN_cntr(4) = '0')then
			SN <= x"ff";
		else
			SN <= SN_T2;
		end if;
		if(S6LinkRdy_n = '1')then
			got_SNp <= '0';
			got_SN <= '0';
		else
			got_SNp <= SN_cntr(4);
			got_SN <= got_SNp;
		end if;
--		if(S6LINK_RxResetDoneSync(2) = '0')then
		if(S6LinkRdy_n = '1')then
			S6LinkCntr <= (others => '0');
		elsif(S6LinkCntr(7) = '0' and linkRxCharIsK(1) = '1' and linkRxdata(15 downto 8) = x"bc")then
			S6LinkCntr <= S6LinkCntr + 1;
		end if;
		if(S6LinkCntr(7) = '0')then
			SN_cntr <= (others => '0');
		elsif(linkRxCharIsK(1) = '0' and SN_cntr(4) = '0')then
			SN_T2 <= linkRxdata(15 downto 8);
			if(SN_T2 = linkRxdata(15 downto 8))then
				SN_cntr <= SN_cntr + 1;
			else
				SN_cntr <= (others => '0');
			end if;
		end if;
		if(div(3) = '1')then
			linkTxCharIsK(0) <= '1';
			linkTxdata(7 downto 0) <= x"bc"; -- K28.5
			div <= (others => '0');
		else
			linkTxCharIsK(0) <= '0';
			linkTxdata(7 downto 0) <= x"00";
			div <= div + 1;
		end if;
	end if;
end process;


end Behavioral;

